module Position.Funktionen where

import Datentypen
import Debug.Trace
import Beispiele


getLength_pos_sub :: Pos_Symbol -> [Position] -> Integer
getLength_pos_sub p [] = 0
getLength_pos_sub p ((Pos k [Laeng x]):ys) =  case p of 
                                               Z a -> 1
                                               otherwise -> if p==k then x
                                                                    else getLength_pos_sub p ys

getLength_pos :: Pos_Symbol -> [Position] -> Integer
getLength_pos x y = getLength_pos_sub x y


getProd_pos :: Pos_Symbol -> [Position] -> Position
getProd_pos x [] = error "Keine Grammatik ! Module Position.Funktionen , Funktion getProd_pos"
getProd_pos x ((Pos p liste):xs) = if p==x then (Pos p liste)
                                           else getProd_pos x xs



--traverse_suffix (Pos (PT "TN_A_s,14") (reverse_sub[Z 1,PT "TN_A,13"]))  (reverseR_Liste beispielAS) ((getLength (PT "TN_A_s,14") beispielAS)-1) 1 (Pos (PT "dummy") [])
traverse_suffix_pos :: Position -> [Position] -> Integer -> Integer -> Position -> [Position] -> Integer -> (Position,Integer)
traverse_suffix_pos (Pos p []) prods m zaehler (Pos (PT h) liste) lliste lsuffix = ((Pos (PT (show zaehler)) (liste)),zaehler)
traverse_suffix_pos (Pos p (x:xs)) prods m zaehler (Pos (PT h) liste) lliste lsuffix =
                                                                 let summe  = lletzte + lsuffix
                                                                     letzte = (last (x:xs))
                                                                     lletzte= (getLength_pos letzte lliste)

                                                                 in
                                                                 if summe == m
                                                                 then ((Pos (PT (show zaehler)) ([letzte]++liste)),(zaehler+1))
                                                                 else
                                                                 if summe < m 
                                                                 then 
                                                                 traverse_suffix_pos (Pos p (take ((length (x:xs))-1) (x:xs))) prods m zaehler (Pos (PT (show zaehler)) ([letzte]++liste)) lliste (lsuffix+lletzte)
                                                                 else
                                                                 traverse_suffix_pos (getProd_pos letzte prods) prods m zaehler (Pos (PT (show zaehler)) liste) lliste lsuffix


umwandeln :: [Position]->[ProdPre]
umwandeln x = umwandeln_sub x

umwandeln_sub::[Position]->[ProdPre]
umwandeln_sub []                          = []
umwandeln_sub ((Pos y list):xs)  = case y of 
                                                (PT a)         ->   ProdPreOrder (P a) (umwandeln1 list):umwandeln_sub xs
                                                (H a)          ->   ProdPreOrder (L a) (umwandeln1 list):umwandeln_sub xs
                                                otherwise      ->   error "unerlaubte Produktion"

--das R und L dürfen nicht auf dasselbe N a abgebildet werden!!!! Im Bsp vom Skript trat der Fehler nicht auf, da die R's verschwunden sind, weil sie Lambda gebildet haben 
umwandeln1 :: [Pos_Symbol] -> [STG_Pre_Symbol]
umwandeln1 [] = []
umwandeln1 (x:xs) = case x of
                           Z a       ->  (K (show a)) : umwandeln1 xs
                           H a       ->  (L a)        : umwandeln1 xs
                           PT a      ->  (P a)        : umwandeln1 xs
                           Laeng a   ->  Laenge a     : umwandeln1 xs
