module Position.Wordlength where

import Datentypen

-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-- -- O(n^2)
-- --wordLength beispiel1
---Berechnet die Laengn jeder Produktion in Pos Grammatik. Die Grammatik darf keine Schleifen oder Produktionen besitzen die nichts produzieren.
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------

wordLength_pos::[Position] -> [Position]
wordLength_pos xs = let spl = split_in_two xs in
                   snd (wordLengthCalc spl (snd spl))


wordLengthCalc::([Position],[Position]) -> [Position] -> ([Position],[Position])
wordLengthCalc ([],ts_neu) ts = ([],ts_neu)
wordLengthCalc (ns,ts_neu) [] = wordLengthCalc (ns,ts_neu) ts_neu
wordLengthCalc (ns,ts_neu) (x:ts) = wordLengthCalc (termSubst ns x [] ts_neu) ts


termSubst::[Position]-> Position ->[Position]->[Position] -> ([Position],[Position])
termSubst [] x ns_neu ts_neu = (ns_neu, ts_neu)
termSubst (Pos (k) (xs):ns) (Pos (p) [Laeng n]) ns_neu ts_neu
         | elementR (p) (xs)   = if nurInt(ersetze (Pos (p) [Laeng n]) (xs))
                                 then termSubst ns (Pos (p) [Laeng n]) ns_neu ([Pos (k) [Laeng (addiereLaeng(ersetze (Pos (p) [Laeng n]) (xs)))]]++ts_neu)
                                 else termSubst ns (Pos (p) [Laeng n]) ([Pos (k) (ersetze (Pos (p) [Laeng n]) (xs))]++ns_neu) (ts_neu)
         | otherwise           = termSubst ns (Pos (p) [Laeng n]) ([Pos (k) (xs)]++ns_neu) ts_neu


elementR :: Pos_Symbol -> [Pos_Symbol] -> Bool
elementR x [] = False
elementR x (y:ys) = if x==y then True
                            else elementR x ys 


nurInt :: [Pos_Symbol] -> Bool
nurInt []     = True
nurInt (x:xs) = case x of
                (Laeng a)   -> nurInt xs
                otherwise    -> False 


ersetze :: Position -> [Pos_Symbol] -> [Pos_Symbol]
ersetze x [] = []
ersetze (Pos p [Laeng h]) (y:ys) = if p==y then (Laeng h):ersetze (Pos p [Laeng h]) ys
                                           else         y:ersetze (Pos p [Laeng h]) ys 

addiereLaeng :: [Pos_Symbol] -> Integer
addiereLaeng [] = 0 
addiereLaeng (Laeng x :xs) = (x + addiereLaeng xs)


split_in_two :: [Position] -> ([Position],[Position])
split_in_two x = split_in_two_sub x [] []


split_in_two_sub :: [Position] -> [Position] -> [Position] -> ([Position],[Position])
split_in_two_sub [] mengePTH mengeZ = (mengePTH,mengeZ)
split_in_two_sub ((Pos p []):xs)    mengePTH mengeZ = split_in_two_sub xs mengePTH ((Pos p [Laeng 0]):mengeZ)
split_in_two_sub ((Pos p [Z a]):xs) mengePTH mengeZ = split_in_two_sub xs mengePTH ((Pos p [Laeng 1]):mengeZ)
split_in_two_sub ((Pos (p) ys):xs)  mengePTH mengeZ = split_in_two_sub xs ((Pos (p) (ersetzeF ys)):mengePTH) mengeZ


ersetzeF::[Pos_Symbol] -> [Pos_Symbol]
ersetzeF []     = []
ersetzeF (x:xs) = case x of
                  Z a         -> (Laeng 1): ersetzeF xs
                  otherwise   ->         x: ersetzeF xs

-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
---Berechnet die Laengn jeder Produktion in PreOrder Grammatik. Die Grammatik darf keine Schleifen oder Produktionen besitzen die nichts produzieren.
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------


 
