module ProdPreOrder.Funktionen where

import Datentypen
import Debug.Trace


pruefrechts:: ProdPre -> ProdPre -> Bool
pruefrechts (ProdPreOrder a b) (ProdPreOrder c d) = if b == d then True
                                                              else False

getLength_prod :: ProdPre -> [ProdPre] -> Integer
getLength_prod x y = getLength_prod_sub x y

getLength_prod_sub :: ProdPre -> [ProdPre] -> Integer
getLength_prod_sub p [] = 0
getLength_prod_sub (ProdPreOrder p liste) ((ProdPreOrder k [Laenge x]):ys) =  case p of 
                                                    F x    -> 1
                                                    K x    -> 1
                                                    X x    -> 1
                                                    Lambda -> 0
                                                    otherwise -> if p==k then x
                                                                         else getLength_prod_sub (ProdPreOrder p liste) ys

getLength :: STG_Pre_Symbol -> [ProdPre] -> Integer
getLength x y = getLength_sub x y


getLength_sub :: STG_Pre_Symbol -> [ProdPre] -> Integer
getLength_sub p [] = 0
getLength_sub p ((ProdPreOrder k [Laenge x]):ys) =  case p of 
                                                    F x -> 1
                                                    K x -> 1
                                                    X x -> 1
                                                    Lambda -> 0
                                                    otherwise -> if p==k then x
                                                                         else getLength_sub p ys

getProd :: STG_Pre_Symbol -> [ProdPre] -> ProdPre
getProd x [] = error "Keine Grammatik ! Module ProdPreOrder.Funktionen , Funktion getProd"
getProd x ((ProdPreOrder p liste):xs) = if p==x then (ProdPreOrder p liste)
                                                else getProd x xs


traverse_prefix :: ProdPre -> [ProdPre] -> Integer -> Integer -> ProdPre -> [ProdPre] -> Integer -> ProdPre
traverse_prefix (ProdPreOrder p []) prods m zaehler (ProdPreOrder (P h) liste) lliste lprefix = (ProdPreOrder (P (show zaehler)) (liste))
traverse_prefix (ProdPreOrder p (x:xs)) prods m zaehler (ProdPreOrder (P h) liste) lliste lprefix =
                                                                let summe  = lerste + lprefix
                                                                    lerste = (getLength x lliste)
                                                                 in
                                                                 if lerste == 0
                                                                 then traverse_prefix (ProdPreOrder p xs) prods m zaehler (ProdPreOrder (P (show zaehler)) (liste)) lliste lprefix
                                                                 else
                                                                 if summe == m
                                                                 then (ProdPreOrder (P (show zaehler)) (liste++[x]))
                                                                 else
                                                                 if summe < m 
                                                                 then 
                                                                 traverse_prefix (ProdPreOrder p xs) prods m zaehler (ProdPreOrder (P (show zaehler)) (liste++[x])) lliste  (lprefix+lerste)
                                                                 else
                                                                 traverse_prefix (getProd x prods) prods m zaehler (ProdPreOrder (P (show zaehler)) liste) lliste lprefix




traverse_suffix :: ProdPre -> [ProdPre] -> Integer -> Integer -> ProdPre -> [ProdPre] -> Integer -> ProdPre
traverse_suffix (ProdPreOrder p []) prods m zaehler (ProdPreOrder (P h) liste) lliste lsuffix = (ProdPreOrder (P (show zaehler)) (liste))
traverse_suffix (ProdPreOrder p (x:xs)) prods m zaehler (ProdPreOrder (P h) liste) lliste lsuffix =
                                                                 let summe  = lletzte + lsuffix
                                                                     letzte = (last (x:xs))
                                                                     lletzte= (getLength letzte lliste)

                                                                 in

                                                                 if lletzte == 0
                                                                 then traverse_suffix (ProdPreOrder p (take ((length (x:xs))-1) (x:xs))) prods m zaehler (ProdPreOrder (P (show zaehler)) (liste)) lliste lsuffix
                                                                 else
                                                                 if summe == m
                                                                 then (ProdPreOrder (P (show zaehler)) ([letzte]++liste))
                                                                 else
                                                                 if summe < m 
                                                                 then
                                                                 traverse_suffix (ProdPreOrder p (take ((length (x:xs))-1) (x:xs))) prods m zaehler (ProdPreOrder (P (show zaehler)) ([letzte]++liste)) lliste (lsuffix+lletzte)
                                                                 else
                                                                 traverse_suffix (getProd letzte prods) prods m zaehler (ProdPreOrder (P (show zaehler)) liste) lliste lsuffix

