module STG.Wordlength where
import Datentypen

-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-- -- O(n^2)
-- --wordLength beispiel1
---Berechnet die Laengen jeder Produktion in STG_Prod Grammatik. Die Grammatik darf keine Schleifen oder Produktionen besitzen die nichts produzieren.
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------

wordLength_stg::[STG_Prod] -> [STG_Prod]
wordLength_stg xs = let spl = split_in_two xs in
                    snd (wordLengthCalc spl (snd spl))


wordLengthCalc::([STG_Prod],[STG_Prod]) -> [STG_Prod] -> ([STG_Prod],[STG_Prod])
wordLengthCalc ([],ts_neu) ts = ([],ts_neu)
wordLengthCalc (ns,ts_neu) [] = wordLengthCalc (ns,ts_neu) ts_neu
wordLengthCalc (ns,ts_neu) (x:ts) = wordLengthCalc (termSubst ns x [] ts_neu) ts


termSubst::[STG_Prod]->STG_Prod->[STG_Prod]->[STG_Prod] -> ([STG_Prod],[STG_Prod])
termSubst [] x ns_neu ts_neu = (ns_neu, ts_neu)
termSubst (STG_Prod (k) (xs):ns) (STG_Prod (p) [Laenge n]) ns_neu ts_neu
         | elementR (p) (xs)   = if nurInt(ersetze (STG_Prod (p) [Laenge n]) (xs))
                                    then termSubst ns (STG_Prod (p) [Laenge n]) ns_neu ([STG_Prod (k) [Laenge (addiereLaenge(ersetze (STG_Prod (p) [Laenge n]) (xs)))]]++ts_neu)
                                    else termSubst ns (STG_Prod (p) [Laenge n]) ([STG_Prod (k) (ersetze (STG_Prod (p) [Laenge n]) (xs))]++ns_neu) (ts_neu)
         | otherwise           = if nurInt(ersetze (STG_Prod (p) [Laenge n]) (xs)) 
                                 then termSubst ns (STG_Prod (p) [Laenge n]) ns_neu ([STG_Prod (k) [Laenge (addiereLaenge(xs))]]++ts_neu)
                                 else
                                  termSubst ns (STG_Prod (p) [Laenge n]) ([STG_Prod (k) (xs)]++ns_neu) ts_neu


elementR :: STG_Pre_Symbol -> [STG_Pre_Symbol] -> Bool
elementR x [] = False
elementR x (y:ys) = if x==y then True
                            else elementR x ys 


nurInt :: [STG_Pre_Symbol] -> Bool
nurInt []     = True
nurInt (x:xs) = case x of
                (Laenge a)   -> nurInt xs
                otherwise    -> False 


ersetze :: STG_Prod -> [STG_Pre_Symbol] -> [STG_Pre_Symbol]
ersetze x [] = []
ersetze (STG_Prod p [Laenge h]) (y:ys) = if p==y then (Laenge h):ersetze (STG_Prod p [Laenge h]) ys
                                                     else          y:ersetze (STG_Prod p [Laenge h]) ys 

addiereLaenge :: [STG_Pre_Symbol] -> Integer
addiereLaenge [] = 0
addiereLaenge (Laenge x :xs) = (x + addiereLaenge xs)


split_in_two :: [STG_Prod] -> ([STG_Prod],[STG_Prod])
split_in_two x = split_in_two_sub x [] []


split_in_two_sub :: [STG_Prod] -> [STG_Prod] -> [STG_Prod] -> ([STG_Prod],[STG_Prod])
split_in_two_sub [] mengeTNCN mengeKXLoch = (mengeTNCN, mengeKXLoch)
split_in_two_sub ((STG_Prod p [K b]):xs)     mengeTNCN mengeKXLoch = split_in_two_sub xs mengeTNCN ((STG_Prod p [Laenge 1]):mengeKXLoch)
split_in_two_sub ((STG_Prod p [X b]):xs)     mengeTNCN mengeKXLoch = split_in_two_sub xs mengeTNCN ((STG_Prod p [Laenge 1]):mengeKXLoch)
split_in_two_sub ((STG_Prod p [Loch]):xs)    mengeTNCN mengeKXLoch = split_in_two_sub xs mengeTNCN ((STG_Prod p [Laenge 0]):mengeKXLoch)
split_in_two_sub ((STG_Prod (p) ys):xs)      mengeTNCN mengeKXLoch = split_in_two_sub xs ((STG_Prod (p) (ersetzeF ys)):mengeTNCN) mengeKXLoch


ersetzeF::[STG_Pre_Symbol] -> [STG_Pre_Symbol]
ersetzeF []     = []
ersetzeF (x:xs) = case x of 
                  F a         -> (Laenge 1): ersetzeF xs
                  K a         -> (Laenge 1): ersetzeF xs
                  X a         -> (Laenge 1): ersetzeF xs
                  otherwise   ->          x: ersetzeF xs

-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
---Berechnet die Laengen jeder Produktion in PreOrder Grammatik. Die Grammatik darf keine Schleifen oder Produktionen besitzen die nichts produzieren.
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------



