module Beispiele where


import Datentypen


--------------------------------------hat funktioniert (wurde unifiziert)---------
---unifikation beispiel (STG_Prod (TN "A_t") [F "g", TN "B", TN "A"]) (STG_Prod (TN "A_s") [F "g", TN "A", TN "A"])
beispiel :: [STG_Prod]
beispiel = [ STG_Prod (TN "A_t") [F "g", TN "B", TN "A"],
             STG_Prod (TN "A_s") [F "g", TN "A", TN "A"],
             STG_Prod (TN "A")   [CN "C_4", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B")   [CN "D", TN "B'"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_4") [CN "C_3", CN "C_3"],
             STG_Prod (CN "C_3") [CN "C_2", CN "C_2"],
             STG_Prod (CN "C_2") [CN "C_1", CN "C_1"],
             STG_Prod (CN "C_1") [CN "C_0", CN "C_0"],
             STG_Prod (CN "C_0") [F "f",CN "C'"],
             STG_Prod (CN "C'")  [Loch],
             STG_Prod (CN "D")   [CN "C_3", CN "C_2"]]
             --STG_Prod (TN "A_h") [F "g", TN "B", TN "A"],
             --STG_Prod (TN "A_i") [F "l", TN "B", TN "A"],
             --STG_Prod (TN "A_k") [F "l", TN "B", TN "A"]]

beispielprodpre ::[ProdPre]
beispielprodpre = [
             --ProdPreOrder (P "A1") [F "g",X "x", X "x"],
             --ProdPreOrder (P "1") [F "g",P "B",L "C_0"],
             ProdPreOrder (P "A_t") [F "g", P "B", P "A"],
             ProdPreOrder (P "A_s") [F "g", P "A", P "A"],
             ProdPreOrder (P "A")   [L "C_4", P "A'", R "C_4"],
             ProdPreOrder (P "A'")  [K "a"],
             --ProdPreOrder (P "J")   [P "B'"],
             ProdPreOrder (P "B")   [L "D", P "B'", R "D"],
             ProdPreOrder (L "D")   [L "C_3", L "C_2"],
             ProdPreOrder (R "D")   [R "C_2", R "C_3"],
             ProdPreOrder (P "B'")  [X "x"],
             ProdPreOrder (L "C_4") [L "C_3", L "C_3"],
             ProdPreOrder (L "C_3") [L "C_2", L "C_2"],
             ProdPreOrder (L "C_2") [L "C_1", L "C_1"],
             ProdPreOrder (L "C_1") [L "C_0", L "C_0"],
             ProdPreOrder (L "C_0") [F "f", L "C'"],
             ProdPreOrder (L "C'")  [Lambda],
             ProdPreOrder (R "C_4") [R "C_3", R "C_3"],
             ProdPreOrder (R "C_3") [R "C_2", R "C_2"],
             ProdPreOrder (R "C_2") [R "C_1", R "C_1"],
             ProdPreOrder (R "C_1") [R "C_0", R "C_0"],
             ProdPreOrder (R "C_0") [R "C'"],
             ProdPreOrder (R "C'")  [Lambda]]
             --ProdPreOrder (P "Q")   [P "J"],
             --ProdPreOrder (P "K")   [P "L"],
             --ProdPreOrder (P "L")   [P "Y"],
             --ProdPreOrder (P "Ü")   [P "J", P "L",P "J"],
             --ProdPreOrder (P "Y")   [Lambda]]

beispielposAS :: [Position]
beispielposAS = [Pos (PT "TN_A_s,14") [Z 1,PT "TN_A,13"],
              Pos (PT "TN_A,13")   [PT "CN_C_4,13"],
              Pos (PT "CN_C_4,13") [H "C_3",PT "CN_C_3,5"],
              Pos (PT "CN_C_3,5")  [H "C_2",PT "CN_C_2,1"],
              Pos (PT "CN_C_2,1")  [Z 0],
              Pos (H "C_4") [H "C_3",H "C_3"],
              Pos (H "C_3") [H "C_2",H "C_2"],
              Pos (H "C_2") [H "C_1",H "C_1"],
              Pos (H "C_1") [H "C_0",H "C_0"],
              Pos (H "C_0") [Z 1],
              Pos (H "C'")  [Z 0],
              Pos (H "D") [H "C_3",H "C_2"]] 

beispielposAT :: [Position]
beispielposAT =  [Pos (PT "TN_A_t,14") [Z 1,PT "TN_B,13"],
               Pos (PT "TN_B,13") [H "D",PT "TN_B',1"],
               Pos (PT "TN_B',1") [Z 0],
               Pos (H "C_4") [H "C_3",H "C_3"],
               Pos (H "C_3") [H "C_2",H "C_2"],
               Pos (H "C_2") [H "C_1",H "C_1"],
               Pos (H "C_1") [H "C_0",H "C_0"],
               Pos (H "C_0") [Z 1],
               Pos (H "C'") [Z 0],
               Pos (H "D") [H "C_3",H "C_2"]]

beispielU :: [STG_Prod]
beispielU = [STG_Prod (TN "x") [TN "N'-1"],
             STG_Prod (TN "N'-1") [CN "PT 2-1",TN "A'"],
             STG_Prod (CN "PT 2-1") [CN "C_2",CN "C'"],
             STG_Prod (TN "A_t") [F "g",TN "B",TN "A"],
             STG_Prod (TN "A_s") [F "g",TN "A",TN "A"],
             STG_Prod (TN "A") [CN "C_4",TN "A'"],
             STG_Prod (TN "A'") [K "a"],
             STG_Prod (TN "B") [CN "D",TN "B'"],
             STG_Prod (TN "B'") [TN "x"],
             STG_Prod (CN "C_4") [CN "C_3",CN "C_3"],
             STG_Prod (CN "C_3") [CN "C_2",CN "C_2"],
             STG_Prod (CN "C_2") [CN "C_1",CN "C_1"],
             STG_Prod (CN "C_1") [CN "C_0",CN "C_0"],
             STG_Prod (CN "C_0") [F "f",CN "C'"],
             STG_Prod (CN "C'") [Loch],
             STG_Prod (CN "D") [CN "C_3",CN "C_2"]]




-------Hat funktioniert (wurde unifiziert)------------------------------------------
--unifikation beispiel_1 (STG_Prod (TN "A_t") [F "g",TN "B",TN "A",TN "K"]) (STG_Prod (TN "A_s")  [F "g",TN "A" ,TN "A",TN "A"])
beispiel_1 :: [STG_Prod]
beispiel_1 = [STG_Prod (TN "A_t") [F "g",TN "B",TN "A",TN "K"],
             STG_Prod (TN "A_s")  [F "g",TN "A" ,TN "A",TN "A"],
             STG_Prod (TN "A")   [CN "C_1", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B")   [CN "D", TN "B'"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_4") [CN "C_3", CN "C_3"],
             STG_Prod (CN "C_3") [CN "C_2", CN "C_2"],
             STG_Prod (CN "C_2") [CN "C_1", CN "C_1"],
             STG_Prod (CN "C_1") [CN "C_0", CN "C_0"],
             STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'",TN "A'", TN "A'", TN "A'",TN "A''"],
             STG_Prod (TN "K")   [CN "C_1",TN "B''"],
             STG_Prod (TN "B''") [X "y"],
             STG_Prod (TN "A''") [K "b"],
             STG_Prod (CN "C'")  [F "j" , CN "C''" , TN "A'"],
             STG_Prod (CN "C''") [Loch],
             STG_Prod (CN "D")   [CN "C_0", CN "C_0"]]

beispiel_1U :: [STG_Prod]
beispiel_1U =  [STG_Prod (TN "y") [TN "N'-2"],
                STG_Prod (TN "N'-2") [TN "A'"],
                STG_Prod (TN "x") [TN "N'-1"],
                STG_Prod (TN "N'-1") [TN "A'"],
                STG_Prod (TN "A_t") [F "g",TN "B",TN "A",TN "K"],
                STG_Prod (TN "A_s") [F "g",TN "A",TN "A",TN "A"],
                STG_Prod (TN "A") [CN "C_1",TN "A'"],
                STG_Prod (TN "A'") [K "a"],
                STG_Prod (TN "B") [CN "D",TN "B'"],
                STG_Prod (TN "B'") [TN "x"],
                STG_Prod (CN "C_4") [CN "C_3",CN "C_3"],
                STG_Prod (CN "C_3") [CN "C_2",CN "C_2"],
                STG_Prod (CN "C_2") [CN "C_1",CN "C_1"],
                STG_Prod (CN "C_1") [CN "C_0",CN "C_0"],
                STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'",TN "A'",TN "A'",TN "A'",TN "A''"],
                STG_Prod (TN "K") [CN "C_1",TN "B''"],
                STG_Prod (TN "B''") [TN "y"],
                STG_Prod (TN "A''") [K "b"],
                STG_Prod (CN "C'") [F "j",CN "C''",TN "A'"],
                STG_Prod (CN "C''") [Loch],
                STG_Prod (CN "D") [CN "C_0",CN "C_0"]]


-------Hat funktioniert (wurde NICHT unifiziert)------------------------------------------
---Exception: Nicht unifizierbar, ein Funktionssymbol kann nicht auf eine Konstante abgebildet werden! Mindestens ein root muss eine Variable sein!
--unifikation beispiel_2 (STG_Prod (TN "A_t") [F "g",TN "B",TN "A",TN "K"]) (STG_Prod (TN "A_s")  [F "g",TN "A" ,TN "A",TN "A"])
beispiel_2 :: [STG_Prod]
beispiel_2 = [STG_Prod (TN "A_t") [F "g",TN "B",TN "A",TN "K"],
             STG_Prod (TN "A_s")  [F "g",TN "A" ,TN "A",TN "A"],
             STG_Prod (TN "A")   [CN "C_4", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B")   [CN "D", TN "B'"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_4") [CN "C_3", CN "C_3"],
             STG_Prod (CN "C_3") [CN "C_2", CN "C_2"],
             STG_Prod (CN "C_2") [CN "C_1", CN "C_1"],
             STG_Prod (CN "C_1") [CN "C_0", CN "C_0"],
             STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'"],
             STG_Prod (TN "K")   [CN "C_4",TN "B''"],
             STG_Prod (TN "B''") [X "x"],
             STG_Prod (CN "C'")  [F "j" , CN "C''" , TN "A'"],
             STG_Prod (CN "C''") [Loch],
             STG_Prod (CN "D")   [CN "C_0", CN "C_0"]]


-------Hat funktioniert (wurde unifiziert)------------------------------------------
--unifikation beispiel_3 (STG_Prod (TN "V") [F "z",TN "A_t", TN "A_s"]) (STG_Prod (TN "W") [F "z",TN "A_s", TN "A_t"])
beispiel_3 :: [STG_Prod]
beispiel_3 = [STG_Prod (TN "V") [F "z",TN "A_t", TN "A_s"],
             STG_Prod (TN "W") [F "z",TN "A_s", TN "A_t"],
             STG_Prod (TN "A_t") [F "g",TN "B",TN "K"],
             STG_Prod (TN "A_s")  [F "g",TN "A", TN "A"],
             STG_Prod (TN "A")   [CN "C_2", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B")   [CN "D", TN "B'"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_4") [CN "C_3", CN "C_3"],
             STG_Prod (CN "C_3") [CN "C_2", CN "C_2"],
             STG_Prod (CN "C_2") [CN "C_1", CN "C_1"],
             STG_Prod (CN "C_1") [CN "C_0", CN "C_0"],
             STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'"],
             STG_Prod (TN "K")   [CN "C_1",TN "B''"],
             STG_Prod (TN "B''") [X "y"],
             STG_Prod (CN "C'")  [F "j" , CN "C''" , TN "A'"],
             STG_Prod (CN "C''") [Loch],
             STG_Prod (CN "D")   [CN "C_0", CN "C_0"]]

beispiel_3U :: [STG_Prod]
beispiel_3U = [STG_Prod (TN "y") [TN "N'-2"],
               STG_Prod (TN "N'-2") [CN "PT 3-2",TN "A'"],
               STG_Prod (CN "PT 3-2") [CN "C_1",CN "C''"],
               STG_Prod (TN "x") [TN "N'-1"],
               STG_Prod (TN "N'-1") [CN "PT 3-1",TN "A'"],
               STG_Prod (CN "PT 3-1") [CN "C_1",CN "C''"],
               STG_Prod (TN "V") [F "z",TN "A_t",TN "A_s"],
               STG_Prod (TN "W") [F "z",TN "A_s",TN "A_t"],
               STG_Prod (TN "A_t") [F "g",TN "B",TN "K"],
               STG_Prod (TN "A_s") [F "g",TN "A",TN "A"],
               STG_Prod (TN "A") [CN "C_2",TN "A'"],
               STG_Prod (TN "A'") [K "a"],
               STG_Prod (TN "B") [CN "D",TN "B'"],
               STG_Prod (TN "B'") [TN "x"],
               STG_Prod (CN "C_4") [CN "C_3",CN "C_3"],
               STG_Prod (CN "C_3") [CN "C_2",CN "C_2"],
               STG_Prod (CN "C_2") [CN "C_1",CN "C_1"],
               STG_Prod (CN "C_1") [CN "C_0",CN "C_0"],
               STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'"],
               STG_Prod (TN "K") [CN "C_1",TN "B''"],
               STG_Prod (TN "B''") [TN "y"],
               STG_Prod (CN "C'") [F "j",CN "C''",TN "A'"],
               STG_Prod (CN "C''") [Loch],
               STG_Prod (CN "D") [CN "C_0",CN "C_0"]]


-------Hat funktioniert (wurde NICHT unifiziert), B ist länger als A------------------------------------------
---Exception: Nicht unifizierbar, ein Funktionssymbol kann nicht auf eine Konstante abgebildet werden! Mindestens ein root muss eine Variable sein!
-----Bei Änderung :STG_Prod (TN "B")   [CN "C_0", TN "B'"] , wird unifiziert----------------------------------
--unifikation beispiel_4 (STG_Prod (TN "V") [F "z",TN "A_t", TN "A_s"]) (STG_Prod (TN "W") [F "z",TN "A_s", TN "A_t"])
beispiel_4 :: [STG_Prod]
beispiel_4 = [STG_Prod (TN "V")  [F "z",TN "A_t", TN "A_s"],
             STG_Prod (TN "W")   [F "z",TN "A_s", TN "A_t"],
             STG_Prod (TN "A_t") [F "g",TN "B",TN "K"],
             STG_Prod (TN "A_s") [F "g",TN "A", TN "A"],
             STG_Prod (TN "A")   [CN "C_0", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B")   [CN "D", TN "B'"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_1") [CN "C_0", CN "C_0"],
             STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'"],
             STG_Prod (TN "K")   [CN "C_0",TN "B''"],
             STG_Prod (TN "B''") [X "y"],
             STG_Prod (CN "C'")  [F "j" , CN "C''", TN "A'"],
             STG_Prod (CN "C''") [F "g", CN "C_5", TN "L"],
             STG_Prod (TN "L")   [X "o"],
             STG_Prod (CN "C_5") [Loch],
             STG_Prod (CN "D")   [CN "C_0", CN "C_0"]]


-------Hat funktioniert (wurde NICHT unifiziert)------------------------------------------
---Exception: Nicht unifizierbar, da die Funktionssymbole unterschiedlich sind!
--------Funktionssymbole bei C_00 und C_0 sind unterschiedlich------------------------------
---unifikation beispiel_5 (STG_Prod (TN "A_t") [F "g", TN "B" , TN "A"]) (STG_Prod (TN "A_s") [F "g", TN "A", TN "A"])
beispiel_5 :: [STG_Prod]
beispiel_5 = [ STG_Prod (TN "A_t") [F "g", TN "B" , TN "A"],
             STG_Prod (TN "A_s") [F "g", TN "A", TN "A"],
             STG_Prod (TN "A")   [CN "C_4", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B")   [CN "D1", TN "B'"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_4") [CN "C_3", CN "C_3"],
             STG_Prod (CN "C_3") [CN "C_2", CN "C_2"],
             STG_Prod (CN "C_2") [CN "C_1", CN "C_1"],
             STG_Prod (CN "C_1") [CN "C_0", CN "C_0"],
             STG_Prod (CN "C_0") [F "f",CN "C'"],
             STG_Prod (CN "C'")  [Loch],
             STG_Prod (CN "D1")   [CN "C_22", CN "C_22"],
             STG_Prod (CN "C_22") [CN "C_11", CN "C_11"],
             STG_Prod (CN "C_11") [CN "C_00", CN "C_00"],
             STG_Prod (CN "C_00") [F "j",CN "C'"]
             ]

-------------hat funktioniert, wurde unifiziert-------------------------------------------------
---unifikation beispiel_6 (STG_Prod (TN "A_t") [F "g", TN "B"]) (STG_Prod (TN "A_s") [F "g", TN "A"])
beispiel_6 :: [STG_Prod]
beispiel_6 = [ STG_Prod (TN "A_t") [F "g", TN "B"],
             STG_Prod (TN "A_s") [F "g", TN "A"],
             STG_Prod (TN "A")   [CN "C_2", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B")   [CN "C_2", TN "B'"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_2") [CN "C_1", CN "C_1"],
             STG_Prod (CN "C_1") [CN "C_0", CN "C_0"],
             STG_Prod (CN "C_0") [F "f",CN "C'"],
             STG_Prod (CN "C'")  [Loch]]

beispiel_6U :: [STG_Prod]
beispiel_6U = [STG_Prod (TN "x") [TN "N'-1"],
               STG_Prod (TN "N'-1") [TN "A'"],
               STG_Prod (TN "A_t") [F "g",TN "B"],
               STG_Prod (TN "A_s") [F "g",TN "A"],
               STG_Prod (TN "A") [CN "C_2",TN "A'"],
               STG_Prod (TN "A'") [K "a"],
               STG_Prod (TN "B") [CN "C_2",TN "B'"],
               STG_Prod (TN "B'") [TN "x"],
               STG_Prod (CN "C_2") [CN "C_1",CN "C_1"],
               STG_Prod (CN "C_1") [CN "C_0",CN "C_0"],
               STG_Prod (CN "C_0") [F "f",CN "C'"],
               STG_Prod (CN "C'") [Loch]]


--------------hat funktioniert (wurde unifiziert)------------------------------
---unifikation beispiel_7 (STG_Prod (TN "V") [F "z",TN "B'", TN "A_s"]) (STG_Prod (TN "W") [F "z", TN "A_s",TN "B'"])
beispiel_7 :: [STG_Prod]
beispiel_7 = [STG_Prod (TN "V") [F "z",TN "B'", TN "A_s"],
             STG_Prod (TN "W") [F "z",TN "A_s", TN "A_s"],
             STG_Prod (TN "A_s")  [F "g",TN "A", TN "A"],
             STG_Prod (TN "A")   [CN "C_2", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_2") [CN "C_1", CN "C_1"],
             STG_Prod (CN "C_1") [CN "C_0", CN "C_0"],
             STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'"],
             STG_Prod (CN "C'")  [F "j" , CN "C''" , TN "A'"],
             STG_Prod (CN "C''") [Loch]]

beispiel_7U :: [STG_Prod]
beispiel_7U = [STG_Prod (TN "x") [TN "N'-1"],
               STG_Prod (TN "V") [F "z",TN "B'",TN "A_s"],
               STG_Prod (TN "W") [F "z",TN "A_s",TN "A_s"],
               STG_Prod (TN "A_s") [F "g",TN "A",TN "A"],
               STG_Prod (TN "A") [CN "C_2",TN "A'"],
               STG_Prod (TN "A'") [K "a"],
               STG_Prod (TN "B'") [TN "x"],
               STG_Prod (CN "C_2") [CN "C_1",CN "C_1"],
               STG_Prod (CN "C_1") [CN "C_0",CN "C_0"],
               STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'"],
               STG_Prod (CN "C'") [F "j",CN "C''",TN "A'"],
               STG_Prod (CN "C''") [Loch],
               STG_Prod (TN "N'-1") [TN "A_s"]]



-- unifikation beispiel_8 (STG_Prod (TN "V") [F "z",TN "B'", TN "B''"]) (STG_Prod (TN "W") [F "z",TN "A", TN "B"])
--------------hat funktioniert (wurde unifiziert)-------------------------------------------------------
beispiel_8 :: [STG_Prod]
beispiel_8 = [STG_Prod (TN "V") [F "z",TN "B'", TN "B''"],
             STG_Prod (TN "W") [F "z",TN "A", TN "B"],
             STG_Prod (TN "A")   [F "z", TN "B''", TN "B''"],
             STG_Prod (TN "B")   [F "z", TN "B'''", TN "B'''"],
             STG_Prod (TN "B'")  [X "x_1"],
             STG_Prod (TN "B''")  [X "x_2"],
             STG_Prod (TN "B'''")  [X "x_3"]]

beispiel_8U :: [STG_Prod]
beispiel_8U = [ STG_Prod (TN "x_2") [TN "N'-2"],
                STG_Prod (TN "x_1") [TN "N'-1"],
                STG_Prod (TN "V") [F "z",TN "B'",TN "B''"],
                STG_Prod (TN "W") [F "z",TN "A",TN "B"],
                STG_Prod (TN "A") [F "z",TN "B''",TN "B''"],
                STG_Prod (TN "B") [F "z",TN "B'''",TN "B'''"],
                STG_Prod (TN "B'") [TN "x_1"],
                STG_Prod (TN "B''") [TN "x_2"],
                STG_Prod (TN "B'''") [X "x_3"],
                STG_Prod (TN "N'-1") [TN "A"],
                STG_Prod (TN "N'-2") [TN "B"]]


---------------------------------------------------------------------------------------------
------------muss immer unifiziert werden-----------------------------------------------------
--unifikation beispiel_9 (STG_Prod (TN "V") [F "z",TN "A_t", TN "A_s"]) (STG_Prod (TN "W") [F "z",TN "A_s", TN "A_t"])
beispiel_9 :: [STG_Prod]
beispiel_9 = let cn = erzeuge_cn 15 in
            [STG_Prod (TN "V") [F "z",TN "A_t", TN "A_s"],
             STG_Prod (TN "W") [F "z",TN "A_s", TN "A_t"],
             STG_Prod (TN "A_t") [F "g",TN "B",TN "K"],
             STG_Prod (TN "A_s")  [F "g",TN "A", TN "A"],
             STG_Prod (TN "A")   [CN "C_14", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B")   [CN "D", TN "B'"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'"],
             STG_Prod (TN "K")   [CN "C_1",TN "B''"],
             STG_Prod (TN "B''") [X "y"],
             STG_Prod (CN "C'")  [F "j" , CN "C''" , TN "A'"],
             STG_Prod (CN "C''") [Loch],
             STG_Prod (CN "D")   [CN "C_12", CN "C_12"]]++cn

erzeuge_cn :: Integer -> [STG_Prod]
erzeuge_cn zaehler = let cn = (STG_Prod (CN ("C_"++show zaehler)) [CN ("C_"++show (zaehler-1)), CN ("C_"++show (zaehler-1))])
                     in
                        if zaehler-1 == 0 then [cn] 
                                          else cn : erzeuge_cn (zaehler-1)




-------------hat funktioniert, wurde NICHT unifiziert----------------------------------
----Exception: 1.Nicht unifizierbar! Occurs Check!--------------------------------------
--unifikation beispiel_10 (STG_Prod (TN "A") [CN "C_1",TN "B"]) (STG_Prod (TN "B") [X "x"])
beispiel_10 :: [STG_Prod]
beispiel_10 =  [STG_Prod (TN "A") [CN "C_1",TN "B"],
                STG_Prod (CN "C_1") [F "f", CN "C_3"],
                STG_Prod (CN "C_3") [Loch],
                STG_Prod (CN "C_4") [Loch],
                STG_Prod (TN "B") [X "x"]]


-----------------hat funktioniert, wurde unifiziert--------------------------------------------------------
---unifikation beispiel_13 (STG_Prod (TN "A_s") [F "p", TN "A_11",TN "A_5"]) (STG_Prod (TN "A_t") [F "p", TN "A_111",TN "A_4"])
beispiel_13 :: [STG_Prod]
beispiel_13 =  [STG_Prod (TN "A_t") [F "p", TN "A_111",TN "A_4"],
                STG_Prod (TN "A_s") [F "p", TN "A_11",TN "A_5"],
                STG_Prod (TN "A_111") [CN "C_11", TN "A_5"],
                STG_Prod (TN "A_11") [CN "C_1", TN "A_5"],
                STG_Prod (CN "C_1") [F "h", TN "A_5", CN "C_0", TN "A_5"],
                STG_Prod (CN "C_11") [F "h", TN "A_5", CN "C_0", TN "A_4"],
                STG_Prod (TN "A_4") [X "x_4"],
                STG_Prod (TN "A_5") [K "a"],
                STG_Prod (CN "C_0") [Loch]]


beispiel_13U :: [STG_Prod]
beispiel_13U = [STG_Prod (TN "x_4") [TN "N'-1"],
                STG_Prod (TN "N'-1") [TN "A_5"],
                STG_Prod (TN "A_t") [F "p",TN "A_111",TN "A_4"],
                STG_Prod (TN "A_s") [F "p",TN "A_11",TN "A_5"],
                STG_Prod (TN "A_111") [CN "C_11",TN "A_5"],
                STG_Prod (TN "A_11") [CN "C_1",TN "A_5"],
                STG_Prod (CN "C_1") [F "h",TN "A_5",CN "C_0",TN "A_5"],
                STG_Prod (CN "C_11") [F "h",TN "A_5",CN "C_0",TN "A_4"],
                STG_Prod (TN "A_4") [TN "x_4"],
                STG_Prod (TN "A_5") [K "a"],
                STG_Prod (CN "C_0") [Loch]]

-------------hat funktioniert, wurde unifiziert------------------------------------------------------
--unifikation beispiel_14 (STG_Prod (TN "B") [CN "C_1",TN "L"]) (STG_Prod (TN "C") [CN "C_11",TN "L"])
beispiel_14::[STG_Prod]
beispiel_14 = [ STG_Prod (TN "B") [CN "C_1",TN "L"],
                STG_Prod (TN "L") [X "x"],
                STG_Prod (CN "C_1") [F "h", CN "C_0", TN "K"],
                STG_Prod (TN "K") [K "a"],
                STG_Prod (CN "C_0") [Loch],
                STG_Prod (TN "C") [CN "C_11",TN "L"],
                STG_Prod (CN "C_11") [F "h", CN "C_0", TN "L"]]

beispiel_14U::[STG_Prod]
beispiel_14U = [STG_Prod (TN "x") [TN "N'-1"],
                STG_Prod (TN "N'-1") [TN "K"],
                STG_Prod (TN "B") [CN "C_1",TN "L"],
                STG_Prod (TN "L") [TN "x"],
                STG_Prod (CN "C_1") [F "h",CN "C_0",TN "K"],
                STG_Prod (TN "K") [K "a"],
                STG_Prod (CN "C_0") [Loch],
                STG_Prod (TN "C") [CN "C_11",TN "L"],
                STG_Prod (CN "C_11") [F "h",CN "C_0",TN "L"]]

--------------hat funktioniert, wurde unifiziert----------------------------------------------------------------------------------------
--unifikation beispiel_15 (STG_Prod (TN "A_t") [F "g", TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A"]) (STG_Prod (TN "A_s") [F "g", TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "B"])
beispiel_15 :: [STG_Prod]
beispiel_15 = [ STG_Prod (TN "A_t") [F "g", TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A"],
                STG_Prod (TN "A_s") [F "g", TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "A",TN "A", TN "B"],
                STG_Prod (TN "A")   [CN "C_4", TN "A'"],
                STG_Prod (TN "A'")  [K "a"],
                STG_Prod (TN "B")   [CN "D", TN "B'"],
                STG_Prod (TN "B'")  [X "x"],
                STG_Prod (CN "C_4") [CN "C_3", CN "C_3"],
                STG_Prod (CN "C_3") [CN "C_2", CN "C_2"],
                STG_Prod (CN "C_2") [CN "C_1", CN "C_1"],
                STG_Prod (CN "C_1") [CN "C_0", CN "C_0"],
                STG_Prod (CN "C_0") [F "f",CN "C'"],
                STG_Prod (CN "C'")  [Loch],
                STG_Prod (CN "D")   [CN "C_3", CN "C_2"]]

beispiel_15U :: [STG_Prod]
beispiel_15U = [STG_Prod (TN "x") [TN "N'-1"],
                STG_Prod (TN "N'-1") [CN "PT 2-1",TN "A'"],
                STG_Prod (CN "PT 2-1") [CN "C_2",CN "C'"],
                STG_Prod (TN "A_t") [F "g",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A"],
                STG_Prod (TN "A_s") [F "g",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "A",TN "B"],
                STG_Prod (TN "A") [CN "C_4",TN "A'"],
                STG_Prod (TN "A'") [K "a"],
                STG_Prod (TN "B") [CN "D",TN "B'"],
                STG_Prod (TN "B'") [TN "x"],
                STG_Prod (CN "C_4") [CN "C_3",CN "C_3"],
                STG_Prod (CN "C_3") [CN "C_2",CN "C_2"],
                STG_Prod (CN "C_2") [CN "C_1",CN "C_1"],
                STG_Prod (CN "C_1") [CN "C_0",CN "C_0"],
                STG_Prod (CN "C_0") [F "f",CN "C'"],
                STG_Prod (CN "C'") [Loch],
                STG_Prod (CN "D") [CN "C_3",CN "C_2"]]



----------------hat funktioniert, wurde unifiziert----------------------------------------------------------------
-- unifikation beispiel_16 (STG_Prod (TN "A_s") [CN "C_1" , TN "Y"]) (STG_Prod (TN "A_t") [CN "C_11",TN "X"])
beispiel_16 :: [STG_Prod]
beispiel_16 = [
              STG_Prod (TN "A_s") [CN "C_1" , TN "Y"],
              STG_Prod (TN "A_t") [CN "C_11",TN "X"],
              STG_Prod (CN "C_1")  [F "h",TN "A_1",CN "C_2", TN "A_11"],
              STG_Prod (CN "C_2")  [F "k",TN "A_2",CN "C'", TN "A_22"],
              STG_Prod (CN "C_11") [F "h",TN "A_1",CN "C_22", TN "A_11"],
              STG_Prod (CN "C_22") [F "k",TN "A_2",CN "C_33", TN "A_22"],
              STG_Prod (CN "C_33") [F "l",TN "A_3",TN "A_33",CN "C'"],
              STG_Prod (CN "C'")   [Loch],
              STG_Prod (TN "Y") [X "y"],
              STG_Prod (TN "X") [X "x"],
              STG_Prod (TN "A_1") [K "a1"],
              STG_Prod (TN "A_11") [K "a11"],
              STG_Prod (TN "A_2") [K "a2"],
              STG_Prod (TN "A_22") [K "a22"],
              STG_Prod (TN "A_3") [K "a3"],
              STG_Prod (TN "A_33") [K "a33"],
              STG_Prod (TN "A_4") [K "a4"]
             ]


beispiel_16U :: [STG_Prod]
beispiel_16U = [STG_Prod (TN "y") [TN "N'-1"],
                STG_Prod (TN "N'-1") [CN "PT 1-1",TN "X"],
                STG_Prod (CN "PT 1-1") [CN "C_33",CN "C'"],
                STG_Prod (TN "A_s") [CN "C_1",TN "Y"],
                STG_Prod (TN "A_t") [CN "C_11",TN "X"],
                STG_Prod (CN "C_1") [F "h",TN "A_1",CN "C_2",TN "A_11"],
                STG_Prod (CN "C_2") [F "k",TN "A_2",CN "C'",TN "A_22"],
                STG_Prod (CN "C_11") [F "h",TN "A_1",CN "C_22",TN "A_11"],
                STG_Prod (CN "C_22") [F "k",TN "A_2",CN "C_33",TN "A_22"],
                STG_Prod (CN "C_33") [F "l",TN "A_3",TN "A_33",CN "C'"],
                STG_Prod (CN "C'") [Loch],
                STG_Prod (TN "Y") [TN "y"],
                STG_Prod (TN "X") [X "x"],
                STG_Prod (TN "A_1") [K "a1"],
                STG_Prod (TN "A_11") [K "a11"],
                STG_Prod (TN "A_2") [K "a2"],
                STG_Prod (TN "A_22") [K "a22"],
                STG_Prod (TN "A_3") [K "a3"],
                STG_Prod (TN "A_33") [K "a33"],
                STG_Prod (TN "A_4") [K "a4"]]



----------------hat funktioniert, wurde unifiziert----------------------------------------------------------------
-- unifikation beispiel_18 (STG_Prod (TN "A_t") [CN "C_1", TN "Y"]) (STG_Prod (TN "A_s") [CN "C_2", TN "X"])

beispiel_18 :: [STG_Prod]
beispiel_18 = [ STG_Prod (TN "A_t") [CN "C_1", TN "Y"],
               STG_Prod (TN "A_s") [CN "C_2", TN "X"],
               STG_Prod (CN "C_2") [F "f",TN "Y1",CN "C'", TN "Y1"],
               STG_Prod (CN "C_1") [F "f",TN "Y1",CN "C_11", TN "Y1"],
               STG_Prod (CN "C_11") [F "g",CN "C'"],
               STG_Prod (TN "Y") [K "a"],
               STG_Prod (TN "Y1") [K "a1"],
               STG_Prod (TN "X") [X "x"],
               STG_Prod (CN "C'") [Loch]
             ]

beispiel_18U :: [STG_Prod]
beispiel_18U =  [STG_Prod (TN "x") [TN "N'-1"],
                 STG_Prod (TN "N'-1") [CN "PT 1-1",TN "Y"],
                 STG_Prod (CN "PT 1-1") [CN "C_11",CN "C'"],
                 STG_Prod (TN "A_t") [CN "C_1",TN "Y"],
                 STG_Prod (TN "A_s") [CN "C_2",TN "X"],
                 STG_Prod (CN "C_2") [F "f",TN "Y1",CN "C'",TN "Y1"],
                 STG_Prod (CN "C_1") [F "f",TN "Y1",CN "C_11",TN "Y1"],
                 STG_Prod (CN "C_11") [F "g",CN "C'"],
                 STG_Prod (TN "Y") [K "a"],
                 STG_Prod (TN "Y1") [K "a1"],
                 STG_Prod (TN "X") [TN "x"],
                 STG_Prod (CN "C'") [Loch]]


---------------hat funktioniert, wurde unifiziert--------------------------------------------------------------------------------------
-------unifikation beispiel_19 (STG_Prod (TN "V") [F "z",TN "A_t", TN "A_s"]) (STG_Prod (TN "W") [F "z",TN "A_s", TN "A_s"])


beispiel_19 :: [STG_Prod]
beispiel_19 = [STG_Prod (TN "V") [F "z",TN "A_t", TN "A_s"],
             STG_Prod (TN "W") [F "z",TN "A_s", TN "A_s"],
             STG_Prod (TN "A_s")  [F "g",TN "A", TN "A"],
             STG_Prod (TN "A")   [CN "C_0", TN "A'"],
             STG_Prod (TN "A'")  [K "a"],
             STG_Prod (TN "B'")  [X "x"],
             STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'"],
             STG_Prod (CN "C'")  [F "j" , CN "C''" , TN "A'"],
             STG_Prod (CN "C''") [Loch],
             STG_Prod (TN "A_t")  [F "g",TN "L", TN "A"],
             STG_Prod (TN "L")   [CN "C_M", TN "A'"],
             STG_Prod (CN "C_M") [F "f", TN "A'", CN "C_U"],
             STG_Prod (CN "C_U") [F "j",CN "C_H", TN "B'"],
             STG_Prod (CN "C_H") [Loch]]


beispiel_19U :: [STG_Prod]
beispiel_19U = [STG_Prod (TN "x") [TN "N'-1"],
                STG_Prod (TN "N'-1") [TN "A'"],
                STG_Prod (TN "V") [F "z",TN "A_t",TN "A_s"],
                STG_Prod (TN "W") [F "z",TN "A_s",TN "A_s"],
                STG_Prod (TN "A_s") [F "g",TN "A",TN "A"],
                STG_Prod (TN "A") [CN "C_0",TN "A'"],
                STG_Prod (TN "A'") [K "a"],
                STG_Prod (TN "B'") [TN "x"],
                STG_Prod (CN "C_0") [F "f",TN "A'",CN "C'"],
                STG_Prod (CN "C'") [F "j",CN "C''",TN "A'"],
                STG_Prod (CN "C''") [Loch],
                STG_Prod (TN "A_t") [F "g",TN "L",TN "A"],
                STG_Prod (TN "L") [CN "C_M",TN "A'"],
                STG_Prod (CN "C_M") [F "f",TN "A'",CN "C_U"],
                STG_Prod (CN "C_U") [F "j",CN "C_H",TN "B'"],
                STG_Prod (CN "C_H") [Loch]]


----------------hat funktioniert, wurde unifiziert----------------------------------------------------------------
-- unifikation beispiel_22 (STG_Prod (TN "A_t") [CN "C_1", TN "X"]) (STG_Prod (TN "A_s") [F "f",TN "Y1",TN "Y1", TN "Y1"])

beispiel_22 :: [STG_Prod]
beispiel_22 = [ STG_Prod (TN "A_t") [CN "C_1", TN "X"],
               STG_Prod (TN "A_s") [F "f",TN "Y1",TN "Y1", TN "Y1"],
               STG_Prod (CN "C_1") [F "f",TN "Y1",CN "C'", TN "Y1"],
               STG_Prod (CN "C_11") [F "g",CN "C'"],
               STG_Prod (TN "Y") [K "a"],
               STG_Prod (TN "Y1") [K "a1"],
               STG_Prod (TN "X") [X "x"],
               STG_Prod (CN "C'") [Loch]
             ]

beispiel_22U :: [STG_Prod]
beispiel_22U = [STG_Prod (TN "x") [TN "N'-1"],
                STG_Prod (TN "A_t") [CN "C_1",TN "X"],
                STG_Prod (TN "A_s") [F "f",TN "Y1",TN "Y1",TN "Y1"],
                STG_Prod (CN "C_1") [F "f",TN "Y1",CN "C'",TN "Y1"],
                STG_Prod (CN "C_11") [F "g",CN "C'"],
                STG_Prod (TN "Y") [K "a"],
                STG_Prod (TN "Y1") [K "a1"],
                STG_Prod (TN "X") [TN "x"],
                STG_Prod (CN "C'") [Loch],
                STG_Prod (TN "N'-1") [TN "Y1"]]


----------------hat funktioniert, wurde unifiziert----------------------------------------------------------------
-- unifikation beispiel_23 (STG_Prod (TN "A_t") [CN "C_1", TN "Y1"]) (STG_Prod (TN "A_s") [F "f",TN "Y1",TN "X", TN "Y1"])

beispiel_23 :: [STG_Prod]
beispiel_23 = [ STG_Prod (TN "A_t") [CN "C_1", TN "Y1"],
               STG_Prod (TN "A_s") [F "f",TN "Y1",TN "X", TN "Y1"],
               STG_Prod (CN "C_1") [F "f",TN "Y1",CN "C_11", TN "Y1"],
               STG_Prod (CN "C_11") [F "g",CN "C'"],
               STG_Prod (TN "Y") [K "a"],
               STG_Prod (TN "Y1") [K "a1"],
               STG_Prod (TN "X") [X "x"],
               STG_Prod (CN "C'") [Loch]
             ]

beispiel_23U :: [STG_Prod]
beispiel_23U = [STG_Prod (TN "x") [TN "N'-1"],
                STG_Prod (TN "N'-1") [CN "PT 1-1",TN "Y1"],
                STG_Prod (CN "PT 1-1") [CN "C_11",CN "C'"],
                STG_Prod (TN "A_t") [CN "C_1",TN "Y1"],
                STG_Prod (TN "A_s") [F "f",TN "Y1",TN "X",TN "Y1"],
                STG_Prod (CN "C_1") [F "f",TN "Y1",CN "C_11",TN "Y1"],
                STG_Prod (CN "C_11") [F "g",CN "C'"],
                STG_Prod (TN "Y") [K "a"],
                STG_Prod (TN "Y1") [K "a1"],
                STG_Prod (TN "X") [TN "x"],
                STG_Prod (CN "C'") [Loch]]






----------------hat funktioniert, wurde unifiziert----------------------------------------------------------------
---unifikation beispiel_24 (STG_Prod (TN "A") [F "f" , TN "A1", TN "A2", TN "A3", TN "A4", TN "A5"]) (STG_Prod (TN "B") [F "f" , TN "A8", TN "A9", TN "A10", TN "A11", TN "A12"])
beispiel_24 :: [STG_Prod]
beispiel_24 = [STG_Prod (TN "A") [F "f" , TN "A1", TN "A2", TN "A3", TN "A4", TN "A5"],
              STG_Prod (TN "A1") [X "x"],
              STG_Prod (TN "A2") [CN "C_1", TN "A6"],
              STG_Prod (TN "A6") [K "a"],
              STG_Prod (CN "C_1")  [F "j",TN "A6", TN "A6", CN "C_2", TN "A6", TN "A1_1"],
              STG_Prod (CN "C_2")  [F "t", CN "C_3", TN "A6"],
              STG_Prod (CN "C_3")  [CN "C_4", CN "C_5"],
              STG_Prod (CN "C_4")  [F "h",TN "A6",CN "C_6"],
              STG_Prod (CN "C_6") [Loch],
              STG_Prod (CN "C_5") [CN "C_6", CN "C_7"],
              STG_Prod (CN "C_7")  [F "l", CN "C_6", TN "A6"],
              STG_Prod (TN "A3") [TN "A7"],
              STG_Prod (TN "A7") [F "g",TN "A6", TN "A6", TN "A1_3"],
              STG_Prod (TN "A4") [TN "A6"],
              STG_Prod (TN "A5") [CN "C_5", TN "A1_2"],
              STG_Prod (TN "A1_1") [X "x1"],
              STG_Prod (TN "A1_2") [X "x2"],
              STG_Prod (TN "A1_3") [X "x3"],
              STG_Prod (TN "B") [F "f" , TN "A8", TN "A9", TN "A10", TN "A11", TN "A12"],
              STG_Prod (TN "A8") [X "y"],
              STG_Prod (TN "A9") [CN "C_8", TN "A8_1"],
              STG_Prod (CN "C_8")  [F "j",TN "A8_2", TN "A8_3", CN "C_9", TN "A8_4", TN "A8_5"],
              STG_Prod (CN "C_9")  [F "t", CN "C_10", TN "A8_6"],
              STG_Prod (CN "C_10")  [F "h",TN "A8_7",CN "C_6"],
              STG_Prod (TN "A10") [F "g",TN "A6", TN "A6", TN "A13"],
              STG_Prod (TN "A13") [CN "C_11", TN "A8_9"],
              STG_Prod (CN "C_11")  [F "m",TN "A6",CN "C_6"],
              STG_Prod (TN "A11") [TN "A8_10"],
              STG_Prod (TN "A12") [CN "C_12", TN "A3"],
              STG_Prod (CN "C_12")  [F "l",CN "C_6",TN "A6"],
              STG_Prod (TN "A8_1") [X "y1"],
              STG_Prod (TN "A8_2") [X "y2"],
              STG_Prod (TN "A8_3") [X "y3"],
              STG_Prod (TN "A8_4") [X "y4"],
              STG_Prod (TN "A8_5") [X "y5"],
              STG_Prod (TN "A8_6") [X "y6"],
              STG_Prod (TN "A8_7") [X "y7"],
              STG_Prod (TN "A8_8") [X "y8"],
              STG_Prod (TN "A8_9") [X "y9"],
              STG_Prod (TN "A8_10") [X "y10"]]


beispiel_24U :: [STG_Prod]
beispiel_24U = [STG_Prod (TN "x2") [TN "N'-11"],
                STG_Prod (TN "N'-11") [TN "A3"],
                STG_Prod (TN "y10") [TN "N'-10"],
                STG_Prod (TN "N'-10") [TN "A4"],
                STG_Prod (TN "x3") [TN "N'-9"],
                STG_Prod (TN "N'-9") [TN "A13"],
                STG_Prod (TN "x1") [TN "N'-8"],
                STG_Prod (TN "N'-8") [TN "A8_5"],
                STG_Prod (TN "y4") [TN "N'-7"],
                STG_Prod (TN "N'-7") [TN "A6"],
                STG_Prod (TN "y6") [TN "N'-6"],
                STG_Prod (TN "N'-6") [TN "A6"],
                STG_Prod (TN "y1") [TN "N'-5"],
                STG_Prod (TN "N'-5") [CN "PT 2-5",TN "A6"],
                STG_Prod (CN "PT 2-5") [CN "C_5",CN "C_6"],
                STG_Prod (TN "y7") [TN "N'-4"],
                STG_Prod (TN "N'-4") [TN "A6"],
                STG_Prod (TN "y3") [TN "N'-3"],
                STG_Prod (TN "N'-3") [TN "A6"],
                STG_Prod (TN "y2") [TN "N'-2"],
                STG_Prod (TN "N'-2") [TN "A6"],
                STG_Prod (TN "x") [TN "N'-1"],
                STG_Prod (TN "N'-1") [TN "A8"],
                STG_Prod (TN "A") [F "f",TN "A1",TN "A2",TN "A3",TN "A4",TN "A5"],
                STG_Prod (TN "B") [F "f",TN "A8",TN "A9",TN "A10",TN "A11",TN "A12"],
                STG_Prod (CN "C_1") [F "j",TN "A6",TN "A6",CN "C_2",TN "A6",TN "A1_1"],
                STG_Prod (CN "C_2") [F "t",CN "C_3",TN "A6"],
                STG_Prod (CN "C_3") [CN "C_4",CN "C_5"],
                STG_Prod (CN "C_4") [F "h",TN "A6",CN "C_6"],
                STG_Prod (CN "C_5") [CN "C_6",CN "C_7"],
                STG_Prod (CN "C_6") [Loch],
                STG_Prod (CN "C_7") [F "l",CN "C_6",TN "A6"],
                STG_Prod (CN "C_8") [F "j",TN "A8_2",TN "A8_3",CN "C_9",TN "A8_4",TN "A8_5"],
                STG_Prod (CN "C_9") [F "t",CN "C_10",TN "A8_6"],
                STG_Prod (CN "C_10") [F "h",TN "A8_7",CN "C_6"],
                STG_Prod (CN "C_11") [F "m",TN "A6",CN "C_6"],
                STG_Prod (CN "C_12") [F "l",CN "C_6",TN "A6"],
                STG_Prod (TN "A1") [TN "x"],
                STG_Prod (TN "A1_1") [TN "x1"],
                STG_Prod (TN "A1_2") [TN "x2"],
                STG_Prod (TN "A1_3") [TN "x3"],
                STG_Prod (TN "A2") [CN "C_1",TN "A6"],
                STG_Prod (TN "A3") [TN "A7"],
                STG_Prod (TN "A4") [TN "A6"],
                STG_Prod (TN "A5") [CN "C_5",TN "A1_2"],
                STG_Prod (TN "A6") [K "a"],
                STG_Prod (TN "A7") [F "g",TN "A6",TN "A6",TN "A1_3"],
                STG_Prod (TN "A8") [X "y"],
                STG_Prod (TN "A8_1") [TN "y1"],
                STG_Prod (TN "A8_2") [TN "y2"],
                STG_Prod (TN "A8_3") [TN "y3"],
                STG_Prod (TN "A8_4") [TN "y4"],
                STG_Prod (TN "A8_5") [X "y5"],
                STG_Prod (TN "A8_6") [TN "y6"],
                STG_Prod (TN "A8_7") [TN "y7"],
                STG_Prod (TN "A8_8") [X "y8"],
                STG_Prod (TN "A8_9") [X "y9"],
                STG_Prod (TN "A8_10") [TN "y10"],
                STG_Prod (TN "A9") [CN "C_8",TN "A8_1"],
                STG_Prod (TN "A10") [F "g",TN "A6",TN "A6",TN "A13"],
                STG_Prod (TN "A11") [TN "A8_10"],
                STG_Prod (TN "A12") [CN "C_12",TN "A3"],
                STG_Prod (TN "A13") [CN "C_11",TN "A8_9"]]


----------------hat funktioniert, wurde unifiziert----------------------------------------------------------------
--unifikation beispiel_25 (STG_Prod (TN "A_s") [F "f",TN "a1", TN "A1",TN "a1",TN "A11"]) (STG_Prod (TN "A_t") [F "f",TN "a1", TN "A_1",TN "a1",TN "A_11"])
beispiel_25 :: [STG_Prod]

beispiel_25 = [
                STG_Prod (TN "A_s") [F "f",TN "a1", TN "A1",TN "a1",TN "A11"],
                STG_Prod (TN "A1") [CN "C1", TN "c1"],
                STG_Prod (TN "c1") [K "c1"],
                STG_Prod (CN "C1") [F "h",TN "a3", TN "a4",CN "C2"],
                STG_Prod (CN "C2") [CN "C3",CN "C3"],
                STG_Prod (CN "C3") [F "i", CN "C'", TN "a6"],
                STG_Prod (CN "C'") [Loch],
                STG_Prod (TN "A11") [F "g", TN "a2", TN "A2", TN "a10"],
                STG_Prod (TN "A2")  [F "h", TN "a3", TN "a4", TN "A3"],
                STG_Prod (TN "A3") [CN "C22", TN "c22"],
                STG_Prod (TN "c22") [K "c22"],
                STG_Prod (CN "C22") [CN "C33",CN "C33"],
                STG_Prod (CN "C33") [F "j", TN "a7", CN "C'"],
                STG_Prod (TN "A_t") [F "f",TN "a1", TN "A_1",TN "a1",TN "A_11"],
                STG_Prod (TN "A_1") [F "h",TN "a3", TN "a4",TN "x1"],
                STG_Prod (TN "x1")  [X "x_1"],
                STG_Prod (TN "A_11") [F "g",TN "x2", TN "A_2",TN "x4"],
                STG_Prod (TN "x2")  [X "x_2"],
                STG_Prod (TN "x4")  [X "x_4"],
                STG_Prod (TN "A_2")  [F "h", TN "a3", TN "a4", TN "x3"],
                STG_Prod (TN "x3")  [X "x_3"],
                STG_Prod (TN "a1") [K "a1"],
                STG_Prod (TN "a2") [K "a2"],
                STG_Prod (TN "a3") [K "a3"],
                STG_Prod (TN "a4") [K "a4"],
                STG_Prod (TN "a6") [K "a6"],
                STG_Prod (TN "a7") [K "a7"],
                STG_Prod (TN "a10") [K "a10"]
              ]

beispiel_25U :: [STG_Prod]
beispiel_25U = [STG_Prod (TN "x_4") [TN "N'-4"],
                STG_Prod (TN "x_3") [TN "N'-3"],
                STG_Prod (TN "x_2") [TN "N'-2"],
                STG_Prod (TN "x_1") [TN "N'-1"],
                STG_Prod (TN "N'-1") [CN "PT 2-1",TN "c1"],
                STG_Prod (CN "PT 2-1") [CN "C2",CN "C'"],
                STG_Prod (TN "A_s") [F "f",TN "a1",TN "A1",TN "a1",TN "A11"],
                STG_Prod (TN "A1") [CN "C1",TN "c1"],
                STG_Prod (TN "c1") [K "c1"],
                STG_Prod (CN "C1") [F "h",TN "a3",TN "a4",CN "C2"],
                STG_Prod (CN "C2") [CN "C3",CN "C3"],
                STG_Prod (CN "C3") [F "i",CN "C'",TN "a6"],
                STG_Prod (CN "C'") [Loch],
                STG_Prod (TN "A11") [F "g",TN "a2",TN "A2",TN "a10"],
                STG_Prod (TN "A2") [F "h",TN "a3",TN "a4",TN "A3"],
                STG_Prod (TN "A3") [CN "C22",TN "c22"],
                STG_Prod (TN "c22") [K "c22"],
                STG_Prod (CN "C22") [CN "C33",CN "C33"],
                STG_Prod (CN "C33") [F "j",TN "a7",CN "C'"],
                STG_Prod (TN "A_t") [F "f",TN "a1",TN "A_1",TN "a1",TN "A_11"],
                STG_Prod (TN "A_1") [F "h",TN "a3",TN "a4",TN "x1"],
                STG_Prod (TN "x1") [TN "x_1"],
                STG_Prod (TN "A_11") [F "g",TN "x2",TN "A_2",TN "x4"],
                STG_Prod (TN "x2") [TN "x_2"],
                STG_Prod (TN "x4") [TN "x_4"],
                STG_Prod (TN "A_2") [F "h",TN "a3",TN "a4",TN "x3"],
                STG_Prod (TN "x3") [TN "x_3"],
                STG_Prod (TN "a1") [K "a1"],
                STG_Prod (TN "a2") [K "a2"],
                STG_Prod (TN "a3") [K "a3"],
                STG_Prod (TN "a4") [K "a4"],
                STG_Prod (TN "a6") [K "a6"],
                STG_Prod (TN "a7") [K "a7"],
                STG_Prod (TN "a10") [K "a10"],
                STG_Prod (TN "N'-2") [TN "a2"],
                STG_Prod (TN "N'-3") [TN "A3"],
                STG_Prod (TN "N'-4") [TN "a10"]]


----------------hat funktioniert, wurde unifiziert----------------------------------------------------------------
-----unifikation beispiel_26 (STG_Prod (TN "A_t") [CN "C_1", TN "Y1"]) (STG_Prod (TN "A_s") [CN "C_1", TN "X"])

beispiel_26 :: [STG_Prod]
beispiel_26 = [ STG_Prod (TN "A_t") [CN "C_1", TN "Y1"],
               STG_Prod (TN "A_s") [CN "C_1", TN "X"],
               STG_Prod (CN "C_1") [CN "C'", CN "C'"],
               STG_Prod (TN "Y1") [K "a1"],
               STG_Prod (TN "X") [X "x"],
               STG_Prod (CN "C'") [Loch]
             ]

beispiel_26U :: [STG_Prod]
beispiel_26U = [STG_Prod (TN "x") [TN "N'-1"],
                STG_Prod (TN "A_t") [CN "C_1",TN "Y1"],
                STG_Prod (TN "A_s") [CN "C_1",TN "X"],
                STG_Prod (CN "C_1") [CN "C'",CN "C'"],
                STG_Prod (TN "Y1") [K "a1"],
                STG_Prod (TN "X") [TN "x"],
                STG_Prod (CN "C'") [Loch],
                STG_Prod (TN "N'-1") [TN "A_t"]]



-----------hat funktioniert, wurde NICHT unifiziert----------------------------
----Nicht unifizierbar, eine Konstante kann nicht auf ein Funktionssymbol abgebildet werden! Mindestens ein root muss eine Variable sein!
-----unifikation beispiel_27 (STG_Prod (TN "A_t") [F "f", TN "A_1", TN "A_2"]) (STG_Prod (TN "A_s") [F "f", TN "A_3"])
beispiel_27 :: [STG_Prod]
beispiel_27 = [ STG_Prod (TN "A_t") [F "f", TN "A_1", TN "A_2"],
               STG_Prod (TN "A_s") [F "f", TN "A_3"],
               STG_Prod (TN "A_1") [K "a"],
               STG_Prod (TN "A_2") [K "b"],
               STG_Prod (TN "A_3") [CN "C_1",TN "A_2"],
               STG_Prod (CN "C_1") [F "a", CN "C_2"],
               STG_Prod (CN "C_2") [Loch]
             ]