module Beispiele_neu where

import Datentypen

--ergebnis stimmt mit beispiel überein---
----unifikationSTG bsp "A_t" "A_s"
bsp :: STG
bsp = STG [AfA "A_t" "g" ["B","A"],
           AfA "A_s" "g" ["A","A"],
           ACA "A" "C_4" "A'",
           AfA "A'" "a" [],
           ACA "B" "D" "B'",
           Ax  "B'" "x",
           CCC "C_4" "C_3" "C_3",
           CCC "C_3" "C_2" "C_2",
           CCC "C_2" "C_1" "C_1",
           CCC "C_1" "C_0" "C_0",
           CfAC "C_0" "f" [] "C'" [],
           CLoch "C'",
           CCC "D" "C_3" "C_2"]


--ergebnis stimmt mit beispiel_1 überein---
----unifikationSTG bsp_1 "A_t" "A_s"
bsp_1 :: STG
bsp_1 =  STG [AfA "A_t" "g" ["B","A","K"],
              AfA "A_s" "g" ["A","A","A"],
              ACA "A" "C_1" "A'",
              AfA "A'" "a" [],
              ACA "B" "D" "B'",
              Ax "B'" "x",
              CCC "C_4" "C_3" "C_3",
              CCC "C_3" "C_2" "C_2",
              CCC "C_2" "C_1" "C_1",
              CCC "C_1" "C_0" "C_0",
              CfAC "C_0" "f" ["A'"] "C'" ["A'","A'","A'","A''"],
              ACA "K" "C_1" "B''",
              Ax "B''" "y",
              AfA "A''" "b" [],
              CfAC "C'" "j" [] "C''" ["A'"],
              CLoch "C''",
              CCC "D" "C_0" "C_0"]

--ergebnis stimmt mit beispiel_4 überein---
----unifikationSTG bsp_4 "V" "W"
bsp_4 :: STG
bsp_4 =  STG [AfA "V" "z" ["A_t","A_s"],
             AfA "W" "z" ["A_s","A_t"],
             AfA "A_t" "g" ["B","K"],
             AfA "A_s" "g" ["A","A"],
             ACA "A" "C_0" "A'",
             AfA "A'" "a" [],
             ACA "B" "D" "B'",
             Ax "B'" "x",
             CCC "C_1" "C_0" "C_0",
             CfAC "C_0" "f" ["A'"] "C'" [],
             ACA "K" "C_0" "B''",
             Ax "B''" "y",
             CfAC "C'" "j" [] "C''" ["A'"],
             CfAC "C''" "g" [] "C_5" ["L"],
             Ax "L" "o",
             CLoch "C_5",
             CCC "D" "C_0" "C_0"]


--ergebnis stimmt mit beispiel_24 überein---
----unifikationSTG bsp_24 "A" "B"
bsp_24 :: STG
bsp_24 = STG [AfA "A" "f" ["A1","A2","A3","A4","A5"],
              Ax "A1" "x",
              ACA "A2" "C_1" "A6",
              AfA "A6" "a" [],
              CfAC "C_1" "j" ["A6","A6"] "C_2" ["A6","A1_1"],
              CfAC "C_2" "t" [] "C_3" ["A6"],
              CCC "C_3" "C_4" "C_5",
              CfAC "C_4" "h" ["A6"] "C_6" [],
              CLoch "C_6",
              CCC "C_5" "C_6" "C_7",
              CfAC "C_7" "l" [] "C_6" ["A6"],
              Lam "A3" "A7",
              AfA "A7" "g" ["A6","A6","A1_3"],
              Lam "A4" "A6",
              ACA "A5" "C_5" "A1_2",
              Ax "A1_1" "x1",
              Ax "A1_2" "x2",
              Ax "A1_3" "x3",
              AfA "B" "f" ["A8", "A9","A10","A11","A12"],
              Ax "A8" "y",
              ACA "A9" "C_8" "A8_1",
              CfAC "C_8" "j" ["A8_2","A8_3"] "C_9" ["A8_4","A8_5"],
              CfAC "C_9" "t" [] "C_10" ["A8_6"],
              CfAC "C_10" "h" ["A8_7"] "C_6" [],
              AfA "A10" "g" ["A6","A6","A13"],
              ACA "A13" "C_11" "A8_9",
              CfAC "C_11" "m" ["A6"] "C_6" [],
              Lam "A11" "A8_10",
              ACA "A12" "C_12" "A3",
              CfAC "C_12" "l" [] "C_6" ["A6"],
              Ax "A8_1" "y1",
              Ax "A8_2" "y2",
              Ax "A8_3" "y3",
              Ax "A8_4" "y4",
              Ax "A8_5" "y5",
              Ax "A8_6" "y6",
              Ax "A8_7" "y7",
              Ax "A8_8" "y8",
              Ax "A8_9" "y9",
              Ax "A8_10" "y10"]


----------unifikationSTG (fib 68) "A68" "B"
fib n = STG $ [AfA (a 0) "0" [] , AfA (a 1) "1" [] ] ++ [ AfA (a i) "f" [a (i-1), a (i-2)] | i <- [2..n]] ++ [AfA "B" "f" ["B1","B2"], AfA "B1" "f" ["B3","B4"], Ax "B2" "x", Ax "B3" "x", Ax "B4" "y"]
  where
  a i = "A" ++ show i


----(a i) und (b k) unterscheiden sich in jedem Argument------------
fac n = if n==0 || n==1
        then STG [AfA (a 0) "1" [] , AfA (a 1) "1" [] ]
        else
        STG $ [AfA (a 0) "1" [] , AfA (a 1) "1" [] ] ++ [ AfA (a i) ("f"++show i) (fukt (a (i-1)) i) | i <- [2..n]] ++ [Ax (b k) ("x"++show k) | k <- [1..n]] ++ [AfA "B" ("f"++show n) [(b l) | l <- [1..n]]]
  where
  a i = "A" ++ show i
  b k = "B" ++ show k

fukt :: String -> Integer -> [String]
fukt a i = if i-1==0 then [a]
                     else a : fukt a (i-1)


------(a i) und (b) unterscheiden sich nur im letzten Argument------------
fac1 n = if n==0 || n==1
         then STG [AfA (a 0) "1" [] , AfA (a 1) "1" [] ]
         else
         STG $ [AfA (a 0) "1" [] , AfA (a 1) "1" [] ] ++ [ AfA (a i) ("f"++show i) (fukt (a (i-1)) i) | i <- [2..n]] ++ [AfA "B" ("f"++show n) ((fukt (a (n-1)) (n-1))++["C"])] ++ [Ax "C" "x"]
  where
  a i = "A" ++ show i
