-- ghc --make -O -o test Main.hs
-- ./test unifikationSTG eingabe "A_t" "A_s" 

module Main where

import Unifikation.Unifikation
import System.CPUTime
import Beispiele_neu
import PlandowskiProd.PlandowskiProd (plandowskiProd)
import PlandowskiSTG.PlandowskiSTG (plandowskiSTG)
import PlandowskiSTG_Prod.PlandowskiSTG_Prod (plandowskiSTG_Prod)
import Beispiele_prod
import Beispiele
import Datentypen
import System 


-- ./test unifikation unifstgprod '( STG_Prod ( TN "A_t" ) [F "g", TN "B", TN "A"] )' '( STG_Prod ( TN "A_s" ) [F "g", TN "A", TN "A"] )'
errp = error "Zu wenige Parameter"
errp2 = error "Falsche Funktion eingegeben"

main = do --go 5  
  --where go i = testfib i >> go (i+10)            --go (i*) 
       args <- getArgs
       let (_:_:b:c:d:e:_) = args

       case args of
           (a:as)
             | a == "unifikationSTG" ->
                   if (length args) < 4 then errp else do
		      str <- readFile (args !! 1)
		      --putStrLn str
		      putStrLn "Ausgabedatei wurde erzeugt."
		      let result = unifikationSTG (read(str)) (args !! 2) (args !! 3)
		      appendFile ((args !! 1)++".out") (result)
            | a == "unifikation" ->
                   if (length args) < 4 then errp else do
		      str <- readFile (args !! 1)
		      --putStrLn str
                      putStrLn "Ausgabedatei wurde erzeugt."
		      let result = unifikation (read(str)) (read(args !! 2)) (read(args !! 3))
		      appendFile ((args !! 1)++".out") (result)
            | a == "plandowskiProd" ->
                   if (length args) < 3 then errp else do
		      str <- readFile (args !! 1)
                      str1 <- readFile (args !! 2)
		      putStrLn "Ausgabedatei wurde erzeugt."
                      --putStrLn str
                      --putStrLn str1
		      let result = plandowskiProd (read(str)) (read(str1))
		      appendFile ((args !! 1)++".out") (show result)
            | a == "plandowskiSTG" ->
                   if (length args) < 3 then errp else do
		      str <- readFile (args !! 1)
                      str1 <- readFile (args !! 2)
		      putStrLn "Ausgabedatei wurde erzeugt."
                      --putStrLn str
		      let result = plandowskiSTG (read(str)) (read(str1))
		      appendFile ((args !! 1)++".out") (show result)
            | a == "plandowskiSTG_Prod" ->
                   if (length args) < 3 then errp else do
		      str <- readFile (args !! 1)
                      str1 <- readFile (args !! 2)
		      putStrLn "Ausgabedatei wurde erzeugt."
                      --putStrLn str
		      let result = plandowskiSTG_Prod (read(str)) (read(str1))
		      appendFile ((args !! 1)++".out") (show result)
	    | otherwise -> errp2

           [] -> errp2

{-       if (head args == "unifikationSTG")
                  then do 
                          str    <- readFile (args !! 1)
                          putStrLn str
                          let result = unifikationSTG (read(str)) (args !! 2) (args !! 3)
                          appendFile "out" (result)                     
                  else error  "zonk" -}
       

