module PlandowskiSTG.PlandowskiSTG where

import Datentypen
import PlandowskiSTG_Prod.PlandowskiSTG_Prod (plandowskiSTG_Prod)
import Beispiele_neu
import Beispiele
import Debug.Trace


plandowskiSTG :: STG -> [(String,String)] -> Bool
plandowskiSTG x set = let
                         grammar = convertSTGtoSTG_Prod x
                         testset = findpre set grammar
                      in

                      plandowskiSTG_Prod grammar testset



findpre :: [(String,String)] -> [STG_Prod] -> [(STG_Pre_Symbol,STG_Pre_Symbol)]
findpre testset x = findpre_sub testset x []

findpre_sub :: [(String,String)] -> [STG_Prod] -> [(STG_Pre_Symbol,STG_Pre_Symbol)] -> [(STG_Pre_Symbol,STG_Pre_Symbol)]
findpre_sub (x:xs) ys neup = findpre_sub xs ys (findpre_sub' x ys [] 0 0 neup)
findpre_sub []     ys neup = neup

findpre_sub':: (String,String) -> [STG_Prod] -> [STG_Pre_Symbol] -> Integer -> Integer -> [(STG_Pre_Symbol,STG_Pre_Symbol)] -> [(STG_Pre_Symbol,STG_Pre_Symbol)]
findpre_sub' (a,b) []                  neup za zb temp = error "In der Testmenge kommt ein Nonterminal vor, dass nicht in der Grammatik enthalten ist (Module Pl.STG,findepre)!"
findpre_sub' (a,b) ((STG_Prod c d):ys) neup za zb temp = if za==1 && zb==1
                                                         then ((machtupel neup)++temp)
                                                         else
                                                         case c of
                                                         TN e -> if e==a && e==b
                                                                 then (temp++[(TN e,TN e)])
                                                                 else
                                                                      if za==0 && e==a
                                                                      then findpre_sub' (a,b) ((STG_Prod c d):ys) (neup++[TN e]) (za+1) zb temp
                                                                      else
                                                                           if zb==0 && e==b
                                                                           then findpre_sub' (a,b) ((STG_Prod c d):ys) (neup++[TN e]) za (zb+1) temp
                                                                           else findpre_sub' (a,b) ys neup za zb temp

                                                         CN e -> if e==a && e==b
                                                                 then (temp++[(TN e,TN e)])
                                                                 else
                                                                      if za==0 && e==a
                                                                      then findpre_sub' (a,b) ((STG_Prod c d):ys) (neup++[TN e]) (za+1) zb temp
                                                                      else
                                                                           if zb==0 && e==b
                                                                           then findpre_sub' (a,b) ((STG_Prod c d):ys) (neup++[TN e]) za (zb+1) temp
                                                                           else findpre_sub' (a,b) ys neup za zb temp

machtupel :: [STG_Pre_Symbol] -> [(STG_Pre_Symbol,STG_Pre_Symbol)]
machtupel [x,y] = [(x,y)]
machtupel (x:xs)= error "Fehler Module PlandowskiSTG, Funktion machtupel : Wegen Funktion findpre"