module ProdPreOrder.Wordlength where

import Datentypen
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-- -- O(n^2)
-- --wordLength beispiel1
---Berechnet die Laengen jeder Produktion in PreOrder Grammatik. Die Grammatik darf keine Schleifen oder Produktionen besitzen die nichts produzieren.
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------

wordLength::[ProdPre] -> [ProdPre]
wordLength xs = let spl = split_in_two xs in
                snd (wordLengthCalc spl (snd spl))


wordLengthCalc::([ProdPre],[ProdPre]) -> [ProdPre] -> ([ProdPre],[ProdPre])
wordLengthCalc ([],ts_neu) ts = ([],ts_neu)
wordLengthCalc (ns,ts_neu) [] = wordLengthCalc (ns,ts_neu) ts_neu
wordLengthCalc (ns,ts_neu) (x:ts) = wordLengthCalc (termSubst ns x [] ts_neu) ts


termSubst::[ProdPre]->ProdPre->[ProdPre]->[ProdPre] -> ([ProdPre],[ProdPre])
termSubst [] x ns_neu ts_neu = (ns_neu, ts_neu)
termSubst (ProdPreOrder (k) (xs):ns) (ProdPreOrder (p) [Laenge n]) ns_neu ts_neu
         | elementR (p) (xs)   = if nurInt(ersetze (ProdPreOrder (p) [Laenge n]) (xs))
                                    then termSubst ns (ProdPreOrder (p) [Laenge n]) ns_neu ([ProdPreOrder (k) [Laenge (addiereLaenge(ersetze (ProdPreOrder (p) [Laenge n]) (xs)))]]++ts_neu)
                                    else termSubst ns (ProdPreOrder (p) [Laenge n]) ([ProdPreOrder (k) (ersetze (ProdPreOrder (p) [Laenge n]) (xs))]++ns_neu) (ts_neu)
         | otherwise           = if nurInt(ersetze (ProdPreOrder (p) [Laenge n]) (xs)) 
                                 then termSubst ns (ProdPreOrder (p) [Laenge n]) ns_neu ([ProdPreOrder (k) [Laenge (addiereLaenge(xs))]]++ts_neu)
                                 else
                                  termSubst ns (ProdPreOrder (p) [Laenge n]) ([ProdPreOrder (k) (xs)]++ns_neu) ts_neu


elementR :: STG_Pre_Symbol -> [STG_Pre_Symbol] -> Bool
elementR x [] = False
elementR x (y:ys) = if x==y then True
                            else elementR x ys 


nurInt :: [STG_Pre_Symbol] -> Bool
nurInt []     = True
nurInt (x:xs) = case x of
                (Laenge a)   -> nurInt xs
                otherwise    -> False 


ersetze :: ProdPre -> [STG_Pre_Symbol] -> [STG_Pre_Symbol]
ersetze x [] = []
ersetze (ProdPreOrder p [Laenge h]) (y:ys) = if p==y then (Laenge h):ersetze (ProdPreOrder p [Laenge h]) ys
                                                     else          y:ersetze (ProdPreOrder p [Laenge h]) ys 

addiereLaenge :: [STG_Pre_Symbol] -> Integer
addiereLaenge [] = 0 
addiereLaenge (Laenge x :xs) = (x + addiereLaenge xs)


split_in_two :: [ProdPre] -> ([ProdPre],[ProdPre])
split_in_two x = split_in_two_sub x [] []


split_in_two_sub :: [ProdPre] -> [ProdPre] -> [ProdPre] -> ([ProdPre],[ProdPre])
split_in_two_sub [] mengePLRF mengeKXLambda = (mengePLRF, mengeKXLambda)
split_in_two_sub ((ProdPreOrder p [K b]):xs)      mengePLRF mengeKXLambda = split_in_two_sub xs mengePLRF ((ProdPreOrder p [Laenge 1]):mengeKXLambda)
split_in_two_sub ((ProdPreOrder p [X b]):xs)      mengePLRF mengeKXLambda = split_in_two_sub xs mengePLRF ((ProdPreOrder p [Laenge 1]):mengeKXLambda)
split_in_two_sub ((ProdPreOrder p [F b]):xs)      mengePLRF mengeKXLambda = split_in_two_sub xs mengePLRF ((ProdPreOrder p [Laenge 1]):mengeKXLambda)
split_in_two_sub ((ProdPreOrder p [Lambda]):xs)   mengePLRF mengeKXLambda = split_in_two_sub xs mengePLRF ((ProdPreOrder p [Laenge 0]):mengeKXLambda)
split_in_two_sub ((ProdPreOrder (p) ys):xs)       mengePLRF mengeKXLambda = split_in_two_sub xs ((ProdPreOrder (p) (ersetzeF ys)):mengePLRF) mengeKXLambda


ersetzeF::[STG_Pre_Symbol] -> [STG_Pre_Symbol]
ersetzeF []     = []
ersetzeF (x:xs) = case x of 
                  F a         -> (Laenge 1): ersetzeF xs
                  K a         -> (Laenge 1): ersetzeF xs
                  X a         -> (Laenge 1): ersetzeF xs
                  otherwise   ->          x: ersetzeF xs

-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
---Berechnet die Laengen jeder Produktion in PreOrder Grammatik. Die Grammatik darf keine Schleifen oder Produktionen besitzen die nichts produzieren.
-------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------- 
